unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, DToolbar, Buttons, Menus, DTCommon;

type
  TfrmMain = class(TForm)
    Toolbar: TDToolBar;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    MainMenu1: TMainMenu;
    miToolBar: TMenuItem;
    miHelp: TMenuItem;
    HowtoUseHelp1: TMenuItem;
    SearchforHelpOn1: TMenuItem;
    Contents1: TMenuItem;
    miFile: TMenuItem;
    Exit2: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N4: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Filebar: TDToolBar;
    SpeedButton2: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Options1: TMenuItem;
    AllowTop1: TMenuItem;
    AllowBottom1: TMenuItem;
    AllowLeft1: TMenuItem;
    AllowRight1: TMenuItem;
    AllowFloat1: TMenuItem;
    AllowMove1: TMenuItem;
    DockStatus1: TMenuItem;
    Bottom1: TMenuItem;
    Top1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Float1: TMenuItem;
    FloatOptions1: TMenuItem;
    CloseBox1: TMenuItem;
    Font1: TMenuItem;
    Titlebar1: TMenuItem;
    FontDialog1: TFontDialog;
    spdbtnExit: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    ToolBar1: TMenuItem;
    FloatOptions2: TMenuItem;
    Titlebar2: TMenuItem;
    Font2: TMenuItem;
    CloseBox2: TMenuItem;
    DockStatus2: TMenuItem;
    Float2: TMenuItem;
    Right2: TMenuItem;
    Left2: TMenuItem;
    Top2: TMenuItem;
    Bottom2: TMenuItem;
    Options2: TMenuItem;
    AllowMove2: TMenuItem;
    AllowFloat2: TMenuItem;
    AllowRight2: TMenuItem;
    AllowLeft2: TMenuItem;
    AllowBottom2: TMenuItem;
    AllowTop2: TMenuItem;
    pmFile: TPopupMenu;
    pmiFileTop: TMenuItem;
    pmiFileBottom: TMenuItem;
    pmiFileLeft: TMenuItem;
    pmiFileRight: TMenuItem;
    pmiFileFloat: TMenuItem;
    pmEdit: TPopupMenu;
    pmiEditTop: TMenuItem;
    pmiEditBottom: TMenuItem;
    pmiEditLeft: TMenuItem;
    pmiEditRight: TMenuItem;
    pmiEditFloat: TMenuItem;
    pmTools: TPopupMenu;
    pmiToolTop: TMenuItem;
    pmiToolBottom: TMenuItem;
    pmiToolLeft: TMenuItem;
    pmiToolRight: TMenuItem;
    pmiToolFloat: TMenuItem;
    ctDefault1: TMenuItem;
    ctNone1: TMenuItem;
    ctFont1: TMenuItem;
    ctSmall1: TMenuItem;
    ctStandard1: TMenuItem;
    ctDefault2: TMenuItem;
    ctNone2: TMenuItem;
    ctFont2: TMenuItem;
    ctSmall2: TMenuItem;
    ctStandard2: TMenuItem;
    Show1: TMenuItem;
    Show2: TMenuItem;
    Caption1: TMenuItem;
    Caption2: TMenuItem;
    Options3: TMenuItem;
    Fonts: TComboBox;
    N2: TMenuItem;
    Customize1: TMenuItem;
    btnFonts: TSpeedButton;
    Editbar: TDToolBar;
    SpeedButton7: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Newbar1: TMenuItem;
    Setup1: TMenuItem;
    Style1: TMenuItem;
    Auto1: TMenuItem;
    Custom1: TMenuItem;
    New2: TMenuItem;
    Win31: TMenuItem;
    Panel2: TPanel;
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    RadioGroup2: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    CheckBox7: TCheckBox;
    edFbFloatCaption: TEdit;
    BitBtn1: TBitBtn;
    GroupBox3: TGroupBox;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    ShowHide: TButton;
    CheckBox8: TCheckBox;
    UseControlWidth1: TMenuItem;
    DockWin1: TDToolbar;
    DockWin2: TDToolbar;
    Memo1: TMemo;
    Memo2: TMemo;
    OpenDialog1: TOpenDialog;
    Ctl3DLineStyle1: TMenuItem;
    W95Look1: TMenuItem;
    N3DLine1: TMenuItem;
    SpeedButton8: TSpeedButton;
    StatusLine: TPanel;
    procedure Exit1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure AllowTop1Click(Sender: TObject);
    procedure AllowBottom1Click(Sender: TObject);
    procedure AllowLeft1Click(Sender: TObject);
    procedure AllowRight1Click(Sender: TObject);
    procedure AllowFloat1Click(Sender: TObject);
    procedure AllowMove1Click(Sender: TObject);
    procedure CloseBox1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure spdbtnExitClick(Sender: TObject);
    procedure SpeedButton21Click(Sender: TObject);
    procedure AllowTop2Click(Sender: TObject);
    procedure AllowBottom2Click(Sender: TObject);
    procedure AllowLeft2Click(Sender: TObject);
    procedure AllowRight2Click(Sender: TObject);
    procedure AllowFloat2Click(Sender: TObject);
    procedure AllowMove2Click(Sender: TObject);
    procedure CloseBox2Click(Sender: TObject);
    procedure Font2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edFbFloatCaptionChange(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure Top1Click(Sender: TObject);
    procedure Bottom1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Float1Click(Sender: TObject);
    procedure Top2Click(Sender: TObject);
    procedure Bottom2Click(Sender: TObject);
    procedure Left2Click(Sender: TObject);
    procedure Right2Click(Sender: TObject);
    procedure Float2Click(Sender: TObject);
    procedure FilebarChangeStatus(Sender: TObject;
      PrevDockStatus: TDockStatus);
    procedure ToolbarChangeStatus(Sender: TObject;
      PrevDockStatus: TDockStatus);
    procedure EditBarChangeStatus(Sender: TObject;
      PrevDockStatus: TDockStatus);
    procedure pmEditPopup(Sender: TObject);
    procedure pmiEditTopClick(Sender: TObject);
    procedure pmiEditBottomClick(Sender: TObject);
    procedure pmiEditLeftClick(Sender: TObject);
    procedure pmiEditRightClick(Sender: TObject);
    procedure pmiEditFloatClick(Sender: TObject);
    procedure pmFilePopup(Sender: TObject);
    procedure pmToolsPopup(Sender: TObject);
    procedure pmiFileTopClick(Sender: TObject);
    procedure pmiFileBottomClick(Sender: TObject);
    procedure pmiFileLeftClick(Sender: TObject);
    procedure pmiFileRightClick(Sender: TObject);
    procedure pmiFileFloatClick(Sender: TObject);
    procedure pmiToolTopClick(Sender: TObject);
    procedure pmiToolBottomClick(Sender: TObject);
    procedure pmiToolLeftClick(Sender: TObject);
    procedure pmiToolRightClick(Sender: TObject);
    procedure pmiToolFloatClick(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure RadioButton9Click(Sender: TObject);
    procedure RadioButton10Click(Sender: TObject);
    procedure ShowHideClick(Sender: TObject);
    procedure ctDefault2Click(Sender: TObject);
    procedure ctNone2Click(Sender: TObject);
    procedure ctFont2Click(Sender: TObject);
    procedure ctSmall2Click(Sender: TObject);
    procedure ctStandard2Click(Sender: TObject);
    procedure ctDefault1Click(Sender: TObject);
    procedure ctNone1Click(Sender: TObject);
    procedure ctFont1Click(Sender: TObject);
    procedure ctSmall1Click(Sender: TObject);
    procedure ctStandard1Click(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure Show2Click(Sender: TObject);
    procedure Caption1Click(Sender: TObject);
    procedure Caption2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FilebarDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FilebarDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SetBeginDrag(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure CheckBox8Click(Sender: TObject);
    procedure Customize1Click(Sender: TObject);
    procedure btnFontsClick(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure Newbar1Click(Sender: TObject);
    procedure Auto1Click(Sender: TObject);
    procedure Custom1Click(Sender: TObject);
    procedure New2Click(Sender: TObject);
    procedure Win31Click(Sender: TObject);
    procedure UseControlWidth1Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure N3DLine1Click(Sender: TObject);
    procedure W95Look1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure DockWin1InitBar(Sender: TObject; var DockStatus,
      LastDockStatus: TDockStatus; var DockLeft, DockTop, DockHeight,
      DockWidth, FloatIndex, FLoatLeft, FloatTop, FloatRight,
      FloatBottom: Integer);
    procedure DockWin2InitBar(Sender: TObject; var DockStatus,
      LastDockStatus: TDockStatus; var DockLeft, DockTop, DockHeight,
      DockWidth, FloatIndex, FLoatLeft, FloatTop, FloatRight,
      FloatBottom: Integer);
  private
    { Private declarations }
    OptionVisible : Boolean;
    NewBtn : TSpeedButton;
    NewToolbar : TDToolbar;
    procedure UnChkEdit;
    procedure UnChkTool;
    procedure StyleChange;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation
uses setup;
{$R *.DFM}

procedure TfrmMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.Contents1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  Application.HelpCommand(HELP_QUIT,0);
end;

procedure TfrmMain.Exit2Click(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.AllowTop1Click(Sender: TObject);
begin
  AllowTop1.Checked := not AllowTop1.Checked;
  if AllowTop1.Checked then
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions + [doAllowTop]
  else
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions - [doAllowTop];
end;

procedure TfrmMain.AllowBottom1Click(Sender: TObject);
begin
  AllowBottom1.Checked := not AllowBottom1.Checked;
  if AllowBottom1.Checked then
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions + [doAllowBottom]
  else
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions - [doAllowBottom];
end;

procedure TfrmMain.AllowLeft1Click(Sender: TObject);
begin
  AllowLeft1.Checked := not AllowLeft1.Checked;
  if AllowLeft1.Checked then
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions + [doAllowLeft]
  else
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions - [doAllowLeft];
end;

procedure TfrmMain.AllowRight1Click(Sender: TObject);
begin
  AllowRight1.Checked := not AllowRight1.Checked;
  if AllowRight1.Checked then
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions + [doAllowRight]
  else
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions - [doAllowRight];
end;

procedure TfrmMain.AllowFloat1Click(Sender: TObject);
begin
  AllowFloat1.Checked := not AllowFloat1.Checked;
  if AllowFloat1.Checked then
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions + [doAllowFloat]
  else
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions - [doAllowFloat];
end;

procedure TfrmMain.AllowMove1Click(Sender: TObject);
begin
  AllowMove1.Checked := not AllowMove1.Checked;
  if AllowMove1.Checked then
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions - [doAllowMove]
  else
    Toolbar.Options.DockOptions := Toolbar.Options.DockOptions + [doAllowMove];
end;

procedure TfrmMain.CloseBox1Click(Sender: TObject);
begin
  Toolbar.Options.FloatOptions.CloseBox := not Toolbar.Options.FloatOptions.CloseBox;
  CloseBox1.Checked := not CloseBox1.Checked;
end;

procedure TfrmMain.Font1Click(Sender: TObject);
begin
  FontDialog1.Font := Toolbar.Options.FloatOptions.Font;
  if FontDialog1.Execute then
    Toolbar.Options.FloatOptions.Font := FontDialog1.Font;
end;

procedure TfrmMain.spdbtnExitClick(Sender: TObject);
begin
  close;
end;

procedure TfrmMain.SpeedButton21Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TfrmMain.AllowTop2Click(Sender: TObject);
begin
  if AllowTop2.Checked then
    editbar.Options.DockOptions := editbar.Options.DockOptions - [doAllowTop]
  else
    editbar.Options.DockOptions := editbar.Options.DockOptions + [doAllowTop];
  AllowTop2.Checked := not AllowTop2.Checked;
end;

procedure TfrmMain.AllowBottom2Click(Sender: TObject);
begin
  if AllowBottom2.Checked then
    editbar.Options.DockOptions := editbar.Options.DockOptions - [doAllowBottom]
  else
    editbar.Options.DockOptions := editbar.Options.DockOptions + [doAllowBottom];
  AllowBottom2.Checked := not AllowBottom2.Checked;
end;

procedure TfrmMain.AllowLeft2Click(Sender: TObject);
begin
  if AllowLeft2.Checked then
    editbar.Options.DockOptions := editbar.Options.DockOptions - [doAllowLeft]
  else
    editbar.Options.DockOptions := editbar.Options.DockOptions + [doAllowLeft];
  AllowLeft2.Checked := not AllowLeft2.Checked;
end;

procedure TfrmMain.AllowRight2Click(Sender: TObject);
begin
  if AllowRight2.Checked then
    editbar.Options.DockOptions := editbar.Options.DockOptions - [doAllowRight]
  else
    editbar.Options.DockOptions := editbar.Options.DockOptions +[doAllowRight];
  AllowRight2.Checked := not AllowRight2.Checked;
end;

procedure TfrmMain.AllowFloat2Click(Sender: TObject);
begin
  if AllowFloat2.Checked then
    editbar.Options.DockOptions := editbar.Options.DockOptions - [doAllowFloat]
  else
    editbar.Options.DockOptions := editbar.Options.DockOptions + [doAllowFloat];
  AllowFloat2.Checked := not AllowFloat2.Checked;
end;

procedure TfrmMain.AllowMove2Click(Sender: TObject);
begin
  if AllowMove2.Checked then
    editbar.Options.DockOptions := editbar.Options.DockOptions - [doAllowMove]
  else
    editbar.Options.DockOptions := editbar.Options.DockOptions + [doAllowMove];
  AllowMove2.Checked := not AllowMove2.Checked;
end;

procedure TfrmMain.CloseBox2Click(Sender: TObject);
begin
  editbar.Options.FloatOptions.CloseBox := not editbar.Options.FloatOptions.CloseBox;
  CloseBox2.Checked := not CloseBox2.Checked;
end;

procedure TfrmMain.Font2Click(Sender: TObject);
begin
  FontDialog1.Font := editbar.Options.FloatOptions.Font;
  if FontDialog1.Execute then
    editbar.Options.FloatOptions.Font := FontDialog1.Font;
end;

procedure TfrmMain.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    filebar.Options.DockOptions := filebar.Options.DockOptions + [doAllowTop]
  else
    filebar.Options.DockOptions := filebar.Options.DockOptions - [doAllowTop];
end;

procedure TfrmMain.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
    filebar.Options.DockOptions := filebar.Options.DockOptions + [doAllowBottom]
  else
    filebar.Options.DockOptions := filebar.Options.DockOptions - [doAllowBottom];
end;

procedure TfrmMain.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked then
    filebar.Options.DockOptions := filebar.Options.DockOptions + [doAllowLeft]
  else
    filebar.Options.DockOptions := filebar.Options.DockOptions - [doAllowLeft];
end;

procedure TfrmMain.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked then
    filebar.Options.DockOptions := filebar.Options.DockOptions + [doAllowRight]
  else
    filebar.Options.DockOptions := filebar.Options.DockOptions - [doAllowRight];
end;

procedure TfrmMain.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked then
    filebar.Options.DockOptions := filebar.Options.DockOptions + [doAllowFloat]
  else
    filebar.Options.DockOptions := filebar.Options.DockOptions - [doAllowFloat];
end;

procedure TfrmMain.CheckBox6Click(Sender: TObject);
begin
  if CheckBox6.Checked then
    filebar.Options.DockOptions := filebar.Options.DockOptions + [doAllowMove]
  else
    filebar.Options.DockOptions := filebar.Options.DockOptions - [doAllowMove];
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  FontDialog1.Font := filebar.Options.FloatOptions.Font;
  if FontDialog1.Execute then
  begin
    filebar.Options.FloatOptions.Font := FontDialog1.Font;
    Fonts.Text := filebar.Options.FloatOptions.Font.Name;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Fonts.Clear;
  Fonts.Items := Screen.Fonts;
  Fonts.Text := filebar.Options.FloatOptions.Font.Name;
  CheckBox1.OnClick := nil;
  CheckBox2.OnClick := nil;
  CheckBox3.OnClick := nil;
  CheckBox4.OnClick := nil;
  CheckBox5.OnClick := nil;
  CheckBox6.OnClick := nil;
  CheckBox7.OnClick := nil;
  CheckBox1.Checked := FileBar.Options.DockOptions >= [doAllowTop];
  CheckBox2.Checked := FileBar.Options.DockOptions >= [doAllowBottom];
  CheckBox3.Checked := FileBar.Options.DockOptions >= [doAllowLeft];
  CheckBox4.Checked := FileBar.Options.DockOptions >= [doAllowRight];
  CheckBox5.Checked := FileBar.Options.DockOptions >= [doAllowFloat];
  CheckBox6.Checked := FileBar.Options.DockOptions >= [doAllowMove];
  CheckBox7.Checked := FileBar.Options.FloatOptions.CloseBox;
  edFbFloatCaption.Text := FileBar.Options.FloatOptions.Caption;
  CheckBox1.OnClick := CheckBox1Click;
  CheckBox2.OnClick := CheckBox2Click;
  CheckBox3.OnClick := CheckBox3Click;
  CheckBox4.OnClick := CheckBox4Click;
  CheckBox5.OnClick := CheckBox5Click;
  CheckBox6.OnClick := CheckBox6Click;
  CheckBox7.OnClick := CheckBox7Click;
  case Toolbar.DockStatus of
     dsRight, dsLeft : begin
                         btnFonts.Visible := true;
                         Fonts.Visible    := false;
                       end;
     dsTop, dsBottom,
     dsFloat :         begin
                         btnFonts.Visible := false;
                         Fonts.Visible    := true;
                       end;
  end;
  case Filebar.DockStatus of
    dsTop    : RadioButton1.Checked := true;
    dsBottom : RadioButton2.Checked := true;
    dsLeft   : RadioButton3.Checked := true;
    dsRight  : RadioButton4.Checked := true;
    dsFloat  : RadioButton5.Checked := true;
  end;
  case Filebar.Style of
    tsAutoDetect : Auto1.Checked   := true;
    tsCustom     : Custom1.Checked := true;
    tsNew        : New1.Checked    := true;
    tsWin31      : Win31.Checked   := true;

  end;
  case Toolbar.DockStatus of
    dsTop    : Top1.Checked    := true;
    dsBottom : Bottom1.Checked := true;
    dsLeft   : Left1.Checked   := true;
    dsRight  : Right1.Checked  := true;
    dsFloat  : Float1.Checked  := true;
  end;
  case Editbar.DockStatus of
    dsTop    : Top2.Checked    := true;
    dsBottom : Bottom2.Checked := true;
    dsLeft   : Left2.Checked   := true;
    dsRight  : Right2.Checked  := true;
    dsFloat  : Float2.Checked  := true;
  end;
  if Filebar.Visible = false then
    ShowHide.Caption := 'Show'
  else
    ShowHide.Caption := 'Hide';
end;

procedure TfrmMain.edFbFloatCaptionChange(Sender: TObject);
begin
  FileBar.Options.FloatOptions.Caption := edFbFloatCaption.Text;
end;

procedure TfrmMain.CheckBox7Click(Sender: TObject);
begin
  Filebar.Options.FloatOptions.CloseBox := not Filebar.Options.FloatOptions.CloseBox;
end;

procedure TfrmMain.RadioButton1Click(Sender: TObject);
begin
  filebar.DockStatus := dsTop;
end;

procedure TfrmMain.RadioButton2Click(Sender: TObject);
begin
  filebar.DockStatus := dsBottom;
end;

procedure TfrmMain.RadioButton3Click(Sender: TObject);
begin
  filebar.DockStatus := dsLeft;
end;

procedure TfrmMain.RadioButton4Click(Sender: TObject);
begin
  filebar.DockStatus := dsRight;
end;

procedure TfrmMain.RadioButton5Click(Sender: TObject);
begin
  filebar.DockStatus := dsFloat;
end;

procedure TfrmMain.Top1Click(Sender: TObject);
begin
  Toolbar.DockStatus := dsTop;
end;

procedure TfrmMain.Bottom1Click(Sender: TObject);
begin
  Toolbar.DockStatus := dsBottom;
end;

procedure TfrmMain.Left1Click(Sender: TObject);
begin
  Toolbar.DockStatus := dsLeft;
end;

procedure TfrmMain.Right1Click(Sender: TObject);
begin
  Toolbar.DockStatus := dsRight;
end;

procedure TfrmMain.Float1Click(Sender: TObject);
begin
  Toolbar.DockStatus := dsFloat;
end;

procedure TfrmMain.Top2Click(Sender: TObject);
begin
  Editbar.DockStatus := dsTop;
end;

procedure TfrmMain.Bottom2Click(Sender: TObject);
begin
  Editbar.DockStatus := dsBottom;
end;

procedure TfrmMain.Left2Click(Sender: TObject);
begin
  Editbar.DockStatus := dsLeft;
end;

procedure TfrmMain.Right2Click(Sender: TObject);
begin
  Editbar.DockStatus := dsRight;
end;

procedure TfrmMain.Float2Click(Sender: TObject);
begin
  Editbar.DockStatus := dsFloat;
end;

procedure TfrmMain.FilebarChangeStatus(Sender: TObject;
  PrevDockStatus: TDockStatus);
begin
  case filebar.DockStatus of
    dsTop    : RadioButton1.Checked := true;
    dsBottom : RadioButton2.Checked := true;
    dsLeft   : RadioButton3.Checked := true;
    dsRight  : RadioButton4.Checked := true;
    dsFloat  : RadioButton5.Checked := true;
  end;
  case PrevDockStatus of
    dsTop    : Top1.Checked    := false;
    dsBottom : Bottom1.Checked := false;
    dsLeft   : Left1.Checked   := false;
    dsRight  : Right1.Checked  := false;
    dsFloat  : Float1.Checked  := false;
  end;
  case filebar.DockStatus of
    dsTop    : Top1.Checked    := true;
    dsBottom : Bottom1.Checked := true;
    dsLeft   : Left1.Checked   := true;
    dsRight  : Right1.Checked  := true;
    dsFloat  : Float1.Checked  := true;
  end;

end;

procedure TfrmMain.ToolbarChangeStatus(Sender: TObject;
  PrevDockStatus: TDockStatus);
begin
  case PrevDockStatus of
    dsTop    : Top1.Checked    := false;
    dsBottom : Bottom1.Checked := false;
    dsLeft   : Left1.Checked   := false;
    dsRight  : Right1.Checked  := false;
    dsFloat  : Float1.Checked  := false;
  end;
  Toolbar.disablealign;
  case toolbar.DockStatus of
    dsTop    : begin
                 Top1.Checked     := true;
                 fonts.Visible    := true;
                 btnfonts.Visible := false;
               end;
    dsBottom : begin
                 Bottom1.Checked  := true;
                 fonts.Visible    := true;
                 btnfonts.Visible := false;
               end;
    dsLeft   : begin
                 Left1.Checked    := true;
                 if toolbar.UseControlWidth then
                 begin
                   fonts.Visible    := true;
                   btnfonts.Visible := false;
                 end
                 else
                 begin
                   fonts.Visible    := false;
                   btnfonts.Visible := true;
                 end;
               end;
    dsRight  : begin
                 Right1.Checked   := true;
                 if toolbar.UseControlWidth then
                 begin
                   fonts.Visible    := true;
                   btnfonts.Visible := false;
                 end
                 else
                 begin
                   fonts.Visible    := false;
                   btnfonts.Visible := true;
                 end;
               end;
    dsFloat  : begin
                 Float1.Checked   := true;
                 fonts.Visible    := true;
                 btnfonts.Visible := false;
               end;
  end;
  Toolbar.enablealign;
end;

procedure TfrmMain.EditBarChangeStatus(Sender: TObject;
  PrevDockStatus: TDockStatus);
begin
  case PrevDockStatus of
    dsTop    : Top2.Checked    := false;
    dsBottom : Bottom2.Checked := false;
    dsLeft   : Left2.Checked   := false;
    dsRight  : Right2.Checked  := false;
    dsFloat  : Float2.Checked  := false;
  end;
  case editbar.DockStatus of
    dsTop    : Top2.Checked    := true;
    dsBottom : Bottom2.Checked := true;
    dsLeft   : Left2.Checked   := true;
    dsRight  : Right2.Checked  := true;
    dsFloat  : Float2.Checked  := true;
  end;

end;

procedure TfrmMain.pmEditPopup(Sender: TObject);
begin
  pmiEditTop.Enabled    := false;
  pmiEditBottom.Enabled := false;
  pmiEditLeft.Enabled   := false;
  pmiEditRight.Enabled  := false;
  pmiEditFloat.Enabled  := false;

  pmiEditTop.Enabled    := fileBar.Options.DockOptions >= [doAllowTop];
  pmiEditBottom.Enabled := fileBar.Options.DockOptions >= [doAllowBottom];
  pmiEditLeft.Enabled   := fileBar.Options.DockOptions >= [doAllowLeft];
  pmiEditRight.Enabled  := fileBar.Options.DockOptions >= [doAllowRight];
  pmiEditFloat.Enabled  := fileBar.Options.DockOptions >= [doAllowFloat];

  pmiEditTop.Checked    := false;
  pmiEditBottom.Checked := false;
  pmiEditLeft.Checked   := false;
  pmiEditRight.Checked  := false;
  pmiEditFloat.Checked  := false;

  case Editbar.DockStatus of
    dsTop    : pmiEditTop.Checked    := true;
    dsBottom : pmiEditBottom.Checked := true;
    dsLeft   : pmiEditLeft.Checked   := true;
    dsRight  : pmiEditRight.Checked  := true;
    dsFloat  : pmiEditFloat.Checked  := true;
  end;

end;

procedure TfrmMain.pmiEditTopClick(Sender: TObject);
begin
  editbar.DockStatus := dsTop;
end;

procedure TfrmMain.pmiEditBottomClick(Sender: TObject);
begin
  editbar.DockStatus := dsBottom;
end;

procedure TfrmMain.pmiEditLeftClick(Sender: TObject);
begin
  editbar.DockStatus := dsLeft;
end;

procedure TfrmMain.pmiEditRightClick(Sender: TObject);
begin
  editbar.DockStatus := dsRight;
end;

procedure TfrmMain.pmiEditFloatClick(Sender: TObject);
begin
  editbar.DockStatus := dsFloat;
end;

procedure TfrmMain.pmFilePopup(Sender: TObject);
begin
  pmiFileTop.Enabled    := false;
  pmiFileBottom.Enabled := false;
  pmiFileLeft.Enabled   := false;
  pmiFileRight.Enabled  := false;
  pmiFileFloat.Enabled  := false;

  pmiFileTop.Enabled    := fileBar.Options.DockOptions >= [doAllowTop];
  pmiFileBottom.Enabled := fileBar.Options.DockOptions >= [doAllowBottom];
  pmiFileLeft.Enabled   := fileBar.Options.DockOptions >= [doAllowLeft];
  pmiFileRight.Enabled  := fileBar.Options.DockOptions >= [doAllowRight];
  pmiFileFloat.Enabled  := fileBar.Options.DockOptions >= [doAllowFloat];

  pmiFileTop.Checked    := false;
  pmiFileBottom.Checked := false;
  pmiFileLeft.Checked   := false;
  pmiFileRight.Checked  := false;
  pmiFileFloat.Checked  := false;

  case Filebar.DockStatus of
    dsTop    : pmiFileTop.Checked    := true;
    dsBottom : pmiFileBottom.Checked := true;
    dsLeft   : pmiFileLeft.Checked   := true;
    dsRight  : pmiFileRight.Checked  := true;
    dsFloat  : pmiFileFloat.Checked  := true;
  end;
end;
procedure TfrmMain.pmiFileTopClick(Sender: TObject);
begin
  Filebar.DockStatus := dsTop;
end;

procedure TfrmMain.pmiFileBottomClick(Sender: TObject);
begin
  Filebar.DockStatus := dsBottom;
end;

procedure TfrmMain.pmiFileLeftClick(Sender: TObject);
begin
  Filebar.DockStatus := dsLeft;
end;

procedure TfrmMain.pmiFileRightClick(Sender: TObject);
begin
  Filebar.DockStatus := dsRight;
end;

procedure TfrmMain.pmiFileFloatClick(Sender: TObject);
begin
  Filebar.DockStatus := dsFloat;
end;

procedure TfrmMain.pmToolsPopup(Sender: TObject);
begin
  pmiToolTop.Enabled    := false;
  pmiToolBottom.Enabled := false;
  pmiToolLeft.Enabled   := false;
  pmiToolRight.Enabled  := false;
  pmiToolFloat.Enabled  := false;

  pmiToolTop.Enabled    := ToolBar.Options.DockOptions >= [doAllowTop];
  pmiToolBottom.Enabled := toolBar.Options.DockOptions >= [doAllowBottom];
  pmiToolLeft.Enabled   := toolBar.Options.DockOptions >= [doAllowLeft];
  pmiToolRight.Enabled  := toolBar.Options.DockOptions >= [doAllowRight];
  pmiToolFloat.Enabled  := toolBar.Options.DockOptions >= [doAllowFloat];

  pmiToolTop.Checked    := false;
  pmiToolBottom.Checked := false;
  pmiToolLeft.Checked   := false;
  pmiToolRight.Checked  := false;
  pmiToolFloat.Checked  := false;

  case toolbar.DockStatus of
    dsTop    : pmiToolTop.Checked    := true;
    dsBottom : pmiToolBottom.Checked := true;
    dsLeft   : pmiToolLeft.Checked   := true;
    dsRight  : pmiToolRight.Checked  := true;
    dsFloat  : pmiToolFloat.Checked  := true;
  end;
end;

procedure TfrmMain.pmiToolTopClick(Sender: TObject);
begin
  Toolbar.DockStatus := dsTop;
end;

procedure TfrmMain.pmiToolBottomClick(Sender: TObject);
begin
  Toolbar.DockStatus := dsBottom;
end;

procedure TfrmMain.pmiToolLeftClick(Sender: TObject);
begin
  Toolbar.DockStatus := dsLeft;
end;

procedure TfrmMain.pmiToolRightClick(Sender: TObject);
begin
  Toolbar.DockStatus := dsRight;
end;

procedure TfrmMain.pmiToolFloatClick(Sender: TObject);
begin
  Toolbar.DockStatus := dsFloat;
end;

procedure TfrmMain.RadioButton6Click(Sender: TObject);
begin
  filebar.Options.FloatOptions.CaptionType := ctDefault;
end;

procedure TfrmMain.RadioButton7Click(Sender: TObject);
begin
  filebar.Options.FloatOptions.CaptionType := ctNone;
end;

procedure TfrmMain.RadioButton8Click(Sender: TObject);
begin
  filebar.Options.FloatOptions.CaptionType := ctSmall;
end;

procedure TfrmMain.RadioButton9Click(Sender: TObject);
begin
  filebar.Options.FloatOptions.CaptionType := ctFont;
end;

procedure TfrmMain.RadioButton10Click(Sender: TObject);
begin
  filebar.Options.FloatOptions.CaptionType := ctStandard;
end;

procedure TfrmMain.ShowHideClick(Sender: TObject);
begin
 Filebar.Visible := not Filebar.Visible;
 if Filebar.Visible = false then
   ShowHide.Caption := 'Show'
 else
  ShowHide.Caption := 'Hide';
end;

procedure TfrmMain.ctDefault2Click(Sender: TObject);
begin
  unChkEdit;
  ctDefault2.Checked:=true;
  editbar.Options.FloatOptions.CaptionType := ctDefault;
end;

procedure TfrmMain.ctNone2Click(Sender: TObject);
begin
  unChkEdit;
  ctNone2.Checked:=true;
  editbar.Options.FloatOptions.CaptionType := ctNone;
end;

procedure TfrmMain.ctFont2Click(Sender: TObject);
begin
  unChkEdit;
  ctFont2.Checked:=true;
  editbar.Options.FloatOptions.CaptionType := ctFont;
end;

procedure TfrmMain.ctSmall2Click(Sender: TObject);
begin
  unChkEdit;
  ctSmall2.Checked:=true;
  editbar.Options.FloatOptions.CaptionType := ctSmall;
end;

procedure TfrmMain.ctStandard2Click(Sender: TObject);
begin
  unChkEdit;
  ctStandard2.Checked:=true;
  editbar.Options.FloatOptions.CaptionType := ctStandard;
end;

procedure TfrmMain.ctDefault1Click(Sender: TObject);
begin
  unChkTool;
  ctDefault1.Checked:=true;
  toolbar.Options.FloatOptions.CaptionType := ctDefault;
end;

procedure TfrmMain.ctNone1Click(Sender: TObject);
begin
  unChkTool;
  ctNone1.Checked:=true;
  toolbar.Options.FloatOptions.CaptionType := ctNone;
end;

procedure TfrmMain.ctFont1Click(Sender: TObject);
begin
  unChkTool;
  ctFont1.Checked:=true;
  toolbar.Options.FloatOptions.CaptionType := ctFont;
end;

procedure TfrmMain.ctSmall1Click(Sender: TObject);
begin
  unChkTool;
  ctSmall1.Checked:=true;
  toolbar.Options.FloatOptions.CaptionType := ctSmall;
end;

procedure TfrmMain.ctStandard1Click(Sender: TObject);
begin
  unChkTool;
  ctStandard1.Checked:=true;
  toolbar.Options.FloatOptions.CaptionType := ctStandard;
end;

procedure TfrmMain.UnChkEdit;
begin
  ctDefault2.Checked  := False;
  ctNone2.Checked     := False;
  ctSmall2.Checked    := False;
  ctFont2.Checked     := False;
  ctStandard2.Checked := False;
end;

procedure TfrmMain.UnChkTool;
begin
  ctDefault1.Checked  := False;
  ctNone1.Checked     := False;
  ctSmall1.Checked    := False;
  ctFont1.Checked     := False;
  ctStandard1.Checked := False;
end;

procedure TfrmMain.Show1Click(Sender: TObject);
begin
  if toolbar.Visible = false then
    toolbar.Visible := true;
end;

procedure TfrmMain.Show2Click(Sender: TObject);
begin
  if editbar.Visible = false then
    editbar.Visible := true;
end;

procedure TfrmMain.Caption1Click(Sender: TObject);
begin
  toolbar.Options.FloatOptions.Caption := InputBox('Tool', 'Caption', toolbar.Options.FloatOptions.Caption);
end;

procedure TfrmMain.Caption2Click(Sender: TObject);
begin
  editbar.Options.FloatOptions.Caption := InputBox('Edit', 'Caption', editbar.Options.FloatOptions.Caption);
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  filebar.visible:=false;
  editbar.visible:=false;
  toolbar.visible:=false;
end;

procedure TfrmMain.FilebarDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if (Source is TSpeedbutton) and (TSpeedbutton(Source).Parent <> Sender) then
    Accept := Source is TSpeedButton
  else
    Accept := false;
end;

procedure TfrmMain.FilebarDragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if ((Sender is TDToolbar) ) and (Source is TSpeedButton) then
  begin
    TDToolbar(Sender).disablealign;
    if (TSpeedButton(Source).Parent is TDToolbar) then
    begin
      TSpeedButton(Source).Parent.RemoveControl(TSpeedButton(Source));
      TDToolbar(Sender).Insertcontrol(TSpeedButton(Source));
    {  if (TDToolbar(Sender).DockStatus = dsTop) or
         (TDToolbar(Sender).DockStatus = dsTop) then}
        TSpeedbutton(Source).Left := X;
    {  else }
        TSpeedbutton(Source).Top  := Y;
    end
    else
    begin
      NewBtn             := TSpeedButton.Create(self);
      NewBtn.Parent      := TDToolbar(Sender);
      NewBtn.NumGlyphs   := TSpeedbutton(Source).NumGlyphs;
      NewBtn.OnMouseDown := SetBeginDrag;
      NewBtn.Glyph.Assign(TSpeedbutton(Source).Glyph);
   {   if (TDToolbar(Sender).DockStatus = dsTop) or
         (TDToolbar(Sender).DockStatus = dsTop) then }
        NewBtn.Left := X;
{      else }
        NewBtn.Top  := Y;
    end;
    TDToolbar(Sender).enablealign;
  end;
end;

procedure TfrmMain.SetBeginDrag(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if OptionVisible then
    TSpeedButton(Sender).begindrag(false);
end;

procedure TfrmMain.CheckBox8Click(Sender: TObject);
begin
  spdbtnExit.Visible := CheckBox8.Checked;
end;

procedure TfrmMain.Customize1Click(Sender: TObject);
begin
  OptionVisible := true;
  SetupDlg.Show;
end;

procedure TfrmMain.btnFontsClick(Sender: TObject);
begin
  FontDialog1.Font := filebar.Options.FloatOptions.Font;
  if FontDialog1.Execute then
    filebar.Options.FloatOptions.Font := FontDialog1.Font;
end;

procedure TfrmMain.Setup1Click(Sender: TObject);
begin
  OptionVisible := true;
  SetupDlg.Show;
end;

procedure TfrmMain.Newbar1Click(Sender: TObject);
begin
  RTCInitialize;
  NewToolBar            := TDToolbar.Create(Self);
  NewToolbar.Name       := 'NewToolbar';
  NewToolBar.Parent     := frmMain;
  NewToolbar.OnDragDrop := FilebarDragDrop;
  NewToolbar.OnDragOver := FilebarDragOver;
end;

procedure TfrmMain.Auto1Click(Sender: TObject);
begin
  FileBar.Style := tsAutoDetect;
  StyleChange;
end;

procedure TfrmMain.Custom1Click(Sender: TObject);
begin
  FileBar.Style := tsCustom;
  StyleChange;
end;

procedure TfrmMain.New2Click(Sender: TObject);
begin
  FileBar.Style := tsNew;
  StyleChange;
end;

procedure TfrmMain.Win31Click(Sender: TObject);
begin
  FileBar.Style := tsWin31;
  StyleChange;
end;

procedure TfrmMain.StyleChange;
begin
  Auto1.Checked   := Filebar.Style = tsAutoDetect;
  Custom1.Checked := Filebar.Style = tsCustom;
  New2.Checked    := Filebar.Style = tsNew;
  Win31.Checked   := Filebar.Style = tsWin31;

  Editbar.Style  := FileBar.Style;
  Toolbar.Style  := FileBar.Style;
  DockWin1.Style := FileBar.Style;
  DockWin2.Style := FileBar.Style;
end;

procedure TfrmMain.UseControlWidth1Click(Sender: TObject);
begin
  UseControlWidth1.Checked := not UseControlWidth1.Checked;
  Toolbar.UseControlWidth  := UseControlWidth1.Checked;
end;

procedure TfrmMain.SpeedButton10Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    try
      Memo1.Lines.LoadfromFile(OpenDialog1.FileName);
    except
      Memo1.Lines[0] := 'Can not load the file '+ OpenDialog1.FileName;
    end;
    DockWin1.Options.FloatOptions.Caption := OpenDialog1.FileName;
  end;
end;

procedure TfrmMain.N3DLine1Click(Sender: TObject);
begin
  W95Look1.Checked := false;
  N3DLine1.Checked := true;
  Filebar.Ctl3DLineType  := lt3DLine;
  Editbar.Ctl3DLineType  := lt3DLine;
  Toolbar.Ctl3DLineType  := lt3DLine;
  DockWin1.Ctl3DLineType := lt3DLine;
  DockWin2.Ctl3DLineType := lt3DLine;
end;

procedure TfrmMain.W95Look1Click(Sender: TObject);
begin
  W95Look1.Checked := true;
  N3DLine1.Checked := false;
  Filebar.Ctl3DLineType  := ltW95Look;
  Editbar.Ctl3DLineType  := ltW95Look;
  Toolbar.Ctl3DLineType  := ltW95Look;
  DockWin1.Ctl3DLineType := ltW95Look;
  DockWin2.Ctl3DLineType := ltW95Look;
end;

procedure TfrmMain.SpeedButton8Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    try
      Memo2.Lines.LoadfromFile(OpenDialog1.FileName);
    except
      Memo2.Lines[0] := 'Can not load the file '+ OpenDialog1.FileName;
    end;
    DockWin2.Options.FloatOptions.Caption := OpenDialog1.FileName;
  end;
end;

procedure TfrmMain.DockWin1InitBar(Sender: TObject; var DockStatus,
  LastDockStatus: TDockStatus; var DockLeft, DockTop, DockHeight,
  DockWidth, FloatIndex, FLoatLeft, FloatTop, FloatRight,
  FloatBottom: Integer);
begin
  if FloatIndex = -1 then
  begin
    DockLeft   := -2;
    DockTop    := 33;
    DockHeight := 80;
  end;
end;

procedure TfrmMain.DockWin2InitBar(Sender: TObject; var DockStatus,
  LastDockStatus: TDockStatus; var DockLeft, DockTop, DockHeight,
  DockWidth, FloatIndex, FLoatLeft, FloatTop, FloatRight,
  FloatBottom: Integer);
begin
  if FloatIndex = -1 then
    DockWidth := 155;
end;

end.
